program main
    ! Gegeben sei ein Array a von Zahlen. Wir nennen die Summe eines
    ! zusammenhängenden Teilarrays eine Subsumme (engl. subsum) von a.
    ! Die Aufgabe lautet, für ein gegebenes Array die maximale Subsumme
    ! zu berechnen. (Da das leere Teilarray Summe 0 hat, ist das Ergebnis
    ! >= 0.) 
    ! Schreibe zunächst eine "naive" Lösung und betrachte 
    ! Laufzeitkomplexität sowie Speicherkomplexität.
    ! Finde anschließend eine optimale Lösung, d.h. eine Lösung mit
    ! bestmöglicher Laufzeitkomplexität und
    ! Speicherkomplexität bestmöglich (in der Menge der Lösungen mit bestmöglicher
    ! Laufzeitkomplexität). Mit anderen Worten: Laufzeitkomplexität ist 
    ! wichtiger als Speicherkomplexität.
    implicit none
    integer :: array(10) = [3,-6,14,6,-1,-4,0,2,-5,1]
    ! write(*,*) max_subsum_naiv(array)
    ! write(*,*) max_subsum_optimal(array)
contains
    integer function max_subsum_naiv(array)
        integer, dimension(:), intent(in) :: array
        ! ...
    end function
    integer function max_subsum_optimal(array)
        integer, dimension(:), intent(in) :: array
        ! ...
    end function
end program main