MODULE flug_mod
  IMPLICIT NONE
  PRIVATE
  PUBLIC :: flug, OPERATOR(+)

 TYPE flug
  CHARACTER(LEN=20) :: start, ziel
  REAL :: dauer
  INTEGER :: distanz
 END TYPE

  INTERFACE OPERATOR(+)
    MODULE PROCEDURE FlugKombi
  END INTERFACE

CONTAINS

  FUNCTION FlugKombi(a,b)
    TYPE(flug), INTENT(IN) :: a, b
    TYPE(flug) :: FlugKombi
      FlugKombi%dauer = a%dauer + b%dauer
      FlugKombi%distanz = a%distanz + b%distanz
      FlugKombi%start = a%start
    IF(a%ziel==b%start) THEN
      FlugKombi%ziel = b%ziel
    ELSE
      FlugKombi%ziel = "noch gesucht"
      WRITE(*,*) "Wir brauchen noch einen Zwischenflug zwischen ", a%ziel, " und ", b%start, "."
    END IF
  END FUNCTION

END MODULE


PROGRAM fliegen
  USE flug_mod
  IMPLICIT NONE

  TYPE(flug) :: flug1, flug2, kombi

  WRITE(*,*) "Bitte gib Start, Ziel, Flugdauer und Distanz des ersten Fluges ein."
  READ(*,*) flug1
  WRITE(*,*) "Bitte gib Start, Ziel, Flugdauer und Distanz des zweiten Fluges ein."
  READ(*,*) flug2

  kombi = flug1 + flug2

  WRITE(*,*) "Die Reise von ", kombi%start, " nach ", kombi%ziel, " ist ", &
  &kombi%distanz, " km lang und dauert ", kombi%dauer, " Stunden."

END PROGRAM
