PROGRAM u14_tierheim
  IMPLICIT NONE

  TYPE tier
    CHARACTER(LEN=20) :: name
    INTEGER :: alter = 0
    REAL :: groesse = 0
    LOGICAl :: besitzer = .FALSE.
  END TYPE

TYPE(tier), DIMENSION(:), ALLOCATABLE :: tierheim
TYPE(tier), DIMENSION(:), ALLOCATABLE :: zwischenspeicher
INTEGER :: n, ios, i, id

OPEN(31,FILE="Tierheim.txt",IOSTAT=ios,ACTION="READ",STATUS="OLD")
  IF(ios==0) THEN
    READ(31,*,IOSTAT=ios) n
    IF(ios==0) THEN
      ALLOCATE(tierheim(n))
      DO i=1, n
        READ(31,*,IOSTAT=ios) tierheim(i)
        IF(ios/=0) THEN
          WRITE(*,*) "Einlesen hat nicht geklappt."
          EXIT
        END IF
      END DO

      !!!!!!!!!
      !Alter von Hund Bello erhoehen
      DO i=1, n
        IF(tierheim(i)%name=="Hund Bello") THEN
          tierheim(i)%alter = tierheim(i)%alter +1
        END IF
      END DO

      !Daten zu dem Tier mit eingelesener ID ausgeben
      WRITE(*,*) "Bitte gib die ID von dem Tier ein, von dem die Daten gebraucht werden."
      READ(*,*) id
      WRITE(*,*) tierheim(id)

      !Name und Alter aller Tiere aelter als 5 und juenger als 15 Jahre ausgeben
      DO i=1, n
        IF(tierheim(i)%alter>5.AND.tierheim(i)%alter<15) THEN
          WRITE(*,*) "Das Tier ", tierheim(i)%name, " ist ", tierheim(i)%alter, " Jahre alt."
        END IF
      END DO

      !Namen aller noch verfuegbaren Tiere ausgeben
      DO i=1, n
        IF(.NOT.tierheim(i)%besitzer) THEN
          WRITE(*,*) "Das Tier ", tierheim(i)%name, " hat noch keinen Besitzer in Aussicht."
        END IF
      END DO

      !Pippi Langstrumpf hat sich für Herr Nilsson entschieden
      tierheim(18)%besitzer = .TRUE.

      !Alle Tiere 10% groesser geworden
      tierheim(:)%groesse = 1.1 * tierheim(:)%groesse

      !Tier hinzufuegen in die Liste
      ALLOCATE(zwischenspeicher(n))
      zwischenspeicher = tierheim
      DEALLOCATE(tierheim)
      ALLOCATE(tierheim(n+1))
      tierheim(1:n) = zwischenspeicher
      DEALLOCATE(zwischenspeicher)
      WRITE(*,*) "Bitte gib die Daten zu dem neuen Tier ein."
      READ(*,*) tierheim(n+1)

      !Alles aus der Liste ausgeben
      WRITE(*,*) tierheim
      !!!!!!!!!

      DEALLOCATE(tierheim)
    ELSE
      WRITE(*,*) "Einlesen der Dimension hat nicht geklappt."
    END IF
    CLOSE(31)
  ELSE
    WRITE(*,*) "Oeffnen hat nicht geklappt."
  END IF

END PROGRAM
